from flask import Flask, request, render_template
import pyttsx3, sched, json
from datetime import datetime
from threading import Thread
from api_information import weather_api

app = Flask(__name__)

time_event = {}

time_format = "%Y-%m-%d %H:%M"

expired_alarm = {}

@app.route('/')
def hello_world():
    return render_template("index.html")

@app.route('/setalarm')
def setalarm():
    alarm_time = request.args.get('alarm')
    alarm_event = request.args.get("event")

    if alarm_event != "":
        set_alarm(alarm_time, alarm_event)
    else:
        set_alarm(alarm_time)

    content = {
        "time_event": time_event
    }

    return render_template("index.html", **content)

@app.route('/cancel_alarm')
def cancel_alarm() -> dict:
    alarm = request.args.get("cancel_alarm")

    cancel(alarm)

    content = {
        "time_event": time_event
    }

    return render_template("index.html", **content)

@app.route("/loop")
def repeat(times: int) -> int:

    for times in range(times):
        pass

    return times


@app.route('/weather')
def weather():
    city = request.args.get("city_name")
    # print(city)

    weather_info = weather_api(city)
    # return render_template("index.html")
    return render_template("index.html", **weather_info)

def set_alarm(time: datetime, event: str = "You have a event!" ) -> dict:

    print("set_alarm添加之前", time_event)

    if time in time_event and event != "You have a event!":
        time_event[time] = event
    elif time not in time_event:
        time_event[time] = event

    print("set_alarm添加之后", time_event)

    return time_event

print("global添加之后的", time_event)

def cancel(time: str) -> dict:
    global time_event
    print("cancel 删除之前", time_event)

    try:
        del time_event[time]
        print("删除之后", time_event)
    except IndexError:
        print("There is no event")
    return time_event
print("global删除之后", time_event)

def conc(string: str) -> datetime:

    string = string.split("T")

    try:
        time = datetime.strptime(string[0] + " " + string[1], time_format)
    except:
        pass

    return time


def time_gap(users_time: datetime) -> int:

    while True:

        datetime_now = datetime.now()

        datetime_now = datetime.strftime(datetime_now, time_format)

        datetime_now = datetime.strptime(datetime_now, time_format)

        time_gap = users_time - datetime_now

        time_gap = time_gap.total_seconds()

        if time_gap >= 0.0:
            print(time_gap)
            break
        else:
            continue

        return time_gap

def notifications(message: str) -> None:

    voice = pyttsx3.init()
    voice.say(message)
    voice.runAndWait()

    return None







if __name__ == '__main__':
    app.run(debug=True, host="0.0.0.0", port=9999)
